﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using HeuristicLab.MainForm;

namespace HeuristicLab.Problems.DataAnalysis.Views {
  [View("Transformation Solution View")]
  [Content(typeof(TransformedRegressionSolution), true)]
  public partial class TransformedRegressionSolutionView : RegressionSolutionView {

    public new TransformedRegressionSolution Content {
      get { return (TransformedRegressionSolution)base.Content; }
      set { base.Content = value; }
    }

    public TransformedRegressionSolutionView() {
      InitializeComponent();
      TransformButton.Text = "Re-Apply Transformation";
    }

    protected override void transformButton_Click(object sender, EventArgs e) {
      var originalModel = Content.Model.OriginalModel;
      var transformedProblemData = (IRegressionProblemData)Content.ProblemData.Transform();
      var originalSolution = new RegressionSolution(originalModel, transformedProblemData);
      MainFormManager.MainForm.ShowContent(originalSolution);
    }
  }
}
